new file mode 100644
@@ -0,0 +1,74 @@
+##/bin/bash
+#
+# Copyright (c) 2013 Fusion IO, Inc. All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#
+#
+# common functions for setting up and tearing down a dmflakey device
+
+FLAKEY_ALLOW_WRITES=0
+FLAKEY_DROP_WRITES=1
+
+_init_flakey()
+{
+ local BLK_DEV_SIZE=`blockdev --getsz $SCRATCH_DEV`
+ FLAKEY_DEV=/dev/mapper/flakey-test
+ FLAKEY_TABLE="0 $BLK_DEV_SIZE flakey $SCRATCH_DEV 0 180 0"
+ FLAKEY_TABLE_DROP="0 $BLK_DEV_SIZE flakey $SCRATCH_DEV 0 0 180 1 drop_writes"
+ $DMSETUP_PROG create flakey-test --table "$FLAKEY_TABLE" || \
+ _fatal "failed to create flakey device"
+}
+
+_mount_flakey()
+{
+ mount -t $FSTYP $MOUNT_OPTIONS $FLAKEY_DEV $SCRATCH_MNT
+}
+
+_unmount_flakey()
+{
+ $UMOUNT_PROG $SCRATCH_MNT
+}
+
+_cleanup_flakey()
+{
+ # If dmsetup load fails then we need to make sure to do resume here
+ # otherwise the umount will hang
+ $DMSETUP_PROG resume flakey-test > /dev/null 2>&1
+ $UMOUNT_PROG $SCRATCH_MNT > /dev/null 2>&1
+ $DMSETUP_PROG remove flakey-test > /dev/null 2>&1
+}
+
+# _load_flakey_table <table> [lockfs]
+#
+# This defaults to --nolockfs, which doesn't freeze_fs() before loading the new
+# table, so it simulates power failure.
+_load_flakey_table()
+{
+
+ table="$FLAKEY_TABLE"
+ [ $1 -eq $FLAKEY_DROP_WRITES ] && table="$FLAKEY_TABLE_DROP"
+
+ suspend_opt="--nolockfs"
+ [ $# -gt 1 ] && [ $2 -eq 1 ] && suspend_opt=""
+
+ $DMSETUP_PROG suspend $suspend_opt flakey-test
+ [ $? -ne 0 ] && _fatal "failed to suspend flakey-test"
+
+ $DMSETUP_PROG load flakey-test --table "$table"
+ [ $? -ne 0 ] && _fatal "failed to load table into flakey-test"
+
+ $DMSETUP_PROG resume flakey-test
+ [ $? -ne 0 ] && _fatal "failed to resumeflakey-test"
+}
@@ -41,17 +41,14 @@ status=1 # failure is the default!
_cleanup()
{
- # If dmsetup load fails then we need to make sure to do resume here
- # otherwise the umount will hang
- $DMSETUP_PROG resume flakey-test > /dev/null 2>&1
- $UMOUNT_PROG $SCRATCH_MNT > /dev/null 2>&1
- $DMSETUP_PROG remove flakey-test > /dev/null 2>&1
+ _cleanup_flakey
}
trap "_cleanup; exit \$status" 0 1 2 3 15
# get standard environment, filters and checks
. ./common/rc
. ./common/filter
+. ./common/dmflakey
# real QA test starts here
_supported_fs generic
@@ -63,49 +60,12 @@ _require_dm_flakey
[ -x $here/src/fsync-tester ] || _notrun "fsync-tester not build"
rm -f $seqres.full
-BLK_DEV_SIZE=`blockdev --getsz $SCRATCH_DEV`
-FLAKEY_DEV=/dev/mapper/flakey-test
SEED=1
testfile=$SCRATCH_MNT/$seq.fsync
-FLAKEY_TABLE="0 $BLK_DEV_SIZE flakey $SCRATCH_DEV 0 180 0"
-FLAKEY_TABLE_DROP="0 $BLK_DEV_SIZE flakey $SCRATCH_DEV 0 0 180 1 drop_writes"
-_TEST_OPTIONS=""
-
-_mount_flakey()
-{
- mount -t $FSTYP $MOUNT_OPTIONS $FLAKEY_DEV $SCRATCH_MNT
-}
-
-_unmount_flakey()
-{
- $UMOUNT_PROG $SCRATCH_MNT
-}
-
-_load_flakey_table()
-{
- # _load_flakey_table <table>
-
- table="$FLAKEY_TABLE"
- [ $1 -eq 1 ] && table="$FLAKEY_TABLE_DROP"
-
- suspend_opt=""
- [ $nolockfs -eq 1 ] && suspend_opt="--nolockfs"
-
- $DMSETUP_PROG suspend $suspend_opt flakey-test
- [ $? -ne 0 ] && _fatal "failed to suspend flakey-test"
-
- $DMSETUP_PROG load flakey-test --table "$table"
- [ $? -ne 0 ] && _fatal "failed to load table into flakey-test"
-
- $DMSETUP_PROG resume flakey-test
- [ $? -ne 0 ] && _fatal "failed to resumeflakey-test"
-}
_run_test()
{
# _run_test <testnum> <0 - buffered | 1 - O_DIRECT>
- allow_writes=0
- drop_writes=1
test_num=$1
direct_opt=""
@@ -115,11 +75,11 @@ _run_test()
[ $? -ne 0 ] && _fatal "fsync tester exited abnormally"
_md5_checksum $testfile
- _load_flakey_table $drop_writes
+ _load_flakey_table $FLAKEY_DROP_WRITES $lockfs
_unmount_flakey
#Ok mount so that any recovery that needs to happen is done
- _load_flakey_table $allow_writes
+ _load_flakey_table $FLAKEY_ALLOW_WRITES
_mount_flakey
_md5_checksum $testfile
@@ -134,23 +94,21 @@ _run_test()
_scratch_mkfs >> $seqres.full 2>&1
# Create a basic flakey device that will never error out
-$DMSETUP_PROG create flakey-test --table "$FLAKEY_TABLE"
-[ $? -ne 0 ] && _fatal "failed to create flakey device"
-
+_init_flakey
_mount_flakey
buffered=0
direct=1
for i in $(seq 1 20); do
- nolockfs=0
+ lockfs=1
SEED=$i
echo "Running test $i buffered, normal suspend"
_run_test $i $buffered
echo "Running test $i direct, normal suspend"
_run_test $i $direct
- nolockfs=1
+ lockfs=0
echo "Running test $i buffered, nolockfs"
_run_test $i $buffered
echo "Running test $i direct, nolockfs"
new file mode 100644
@@ -0,0 +1,140 @@
+#! /bin/bash
+# FS QA Test No. 320
+#
+# Runs various dir fsync tests to cover fsync'ing directory corner cases.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2013 Fusion IO. All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+status=1 # failure is the default!
+
+_cleanup()
+{
+ _cleanup_flakey
+}
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/dmflakey
+
+# real QA test starts here
+_supported_fs generic
+_supported_os Linux
+_need_to_be_root
+_require_scratch
+_require_dm_flakey
+
+rm -f $seqres.full
+
+_clean_working_dir()
+{
+ _mount_flakey
+ rm -rf $SCRATCH_MNT/*
+ _unmount_flakey
+}
+
+# Btrfs wasn't making sure the directory survived fsync
+_directory_test()
+{
+ echo "fsync new directory"
+ _mount_flakey
+ mkdir $SCRATCH_MNT/bar
+ $XFS_IO_PROG -c "fsync" $SCRATCH_MNT/bar
+ _load_flakey_table $FLAKEY_DROP_WRITES
+ _unmount_flakey
+
+ _load_flakey_table $FLAKEY_ALLOW_WRITES
+ _mount_flakey
+ _ls_l $SCRATCH_MNT | tail -n +2 | awk '{ print $1, $9 }'
+ _unmount_flakey
+ _check_scratch_fs $FLAKEY_DEV
+ [ $? -ne 0 ] && _fatal "fsck failed"
+}
+
+# Btrfs was losing a rename into a new directory
+_rename_test()
+{
+ echo "rename fsync test"
+ _mount_flakey
+ touch $SCRATCH_MNT/foo
+ mkdir $SCRATCH_MNT/bar
+ $XFS_IO_PROG -c "fsync" $SCRATCH_MNT/foo
+ mv $SCRATCH_MNT/foo $SCRATCH_MNT/bar/foo
+ $XFS_IO_PROG -c "fsync" $SCRATCH_MNT/bar
+ $XFS_IO_PROG -c "fsync" $SCRATCH_MNT/bar/foo
+ _load_flakey_table $FLAKEY_DROP_WRITES
+ _unmount_flakey
+
+ _load_flakey_table $FLAKEY_ALLOW_WRITES
+ _mount_flakey
+ _ls_l $SCRATCH_MNT | tail -n +2 | awk '{ print $1, $9 }'
+ _ls_l $SCRATCH_MNT/bar | tail -n +2 | awk '{ print $1, $9 }'
+ _unmount_flakey
+ _check_scratch_fs $FLAKEY_DEV
+ [ $? -ne 0 ] && _fatal "fsck failed"
+}
+
+# Btrfs was failing to replay a log when we had a inode with a smaller inode
+# number that is renamed into a directory with a higher inode number
+_replay_rename_test()
+{
+ echo "replay rename fsync test"
+ _mount_flakey
+ touch $SCRATCH_MNT/foo
+ mkdir $SCRATCH_MNT/bar
+ $XFS_IO_PROG -c "fsync" $SCRATCH_MNT/foo
+ mv $SCRATCH_MNT/foo $SCRATCH_MNT/bar/foo
+ $XFS_IO_PROG -c "fsync" $SCRATCH_MNT/bar
+
+ # This is to force btrfs to relog the entire inode including the ref so
+ # we are sure to try and replay the ref along with the dir_index item
+ setfattr -n user.foo -v blah $SCRATCH_MNT/bar/foo >> $seqres.full 2>&1
+
+ $XFS_IO_PROG -c "fsync" $SCRATCH_MNT/bar/foo
+ _load_flakey_table $FLAKEY_DROP_WRITES
+ _unmount_flakey
+
+ _load_flakey_table $FLAKEY_ALLOW_WRITES
+ _mount_flakey
+ _ls_l $SCRATCH_MNT | tail -n +2 | awk '{ print $1, $9 }'
+ _ls_l $SCRATCH_MNT/bar | tail -n +2 | awk '{ print $1, $9 }'
+ _unmount_flakey
+ _check_scratch_fs $FLAKEY_DEV
+ [ $? -ne 0 ] && _fatal "fsck failed"
+}
+
+_scratch_mkfs >> $seqres.full 2>&1
+
+# Create a basic flakey device that will never error out
+_init_flakey
+
+_directory_test
+_clean_working_dir
+_rename_test
+_clean_working_dir
+_replay_rename_test
+
+status=0
+exit
new file mode 100644
@@ -0,0 +1,9 @@
+QA output created by 320
+fsync new directory
+drwxr-xr-x bar
+rename fsync test
+drwxr-xr-x bar
+-rw-r--r-- foo
+replay rename fsync test
+drwxr-xr-x bar
+-rw-r--r-- foo
@@ -122,4 +122,5 @@
317 auto metadata quick
318 acl attr auto quick
319 acl auto quick
+320 auto quick metadata log
Btrfs had some issues with fsync()'ing directories and fsync()'ing after renames. These three new tests cover the 3 different issues we were seeing. This breaks out the dmflakey stuff into a common helper to be shared between generic/311 and generic/320. Thanks, Signed-off-by: Josef Bacik <jbacik@fusionio.com> --- V1->V2: moved this out into its own test instead of adding it to 311 common/dmflakey | 74 ++++++++++++++++++++++++++ tests/generic/311 | 56 +++----------------- tests/generic/320 | 140 ++++++++++++++++++++++++++++++++++++++++++++++++++ tests/generic/320.out | 9 ++++ tests/generic/group | 1 + 5 files changed, 231 insertions(+), 49 deletions(-) create mode 100644 common/dmflakey create mode 100644 tests/generic/320 create mode 100644 tests/generic/320.out